CMSIS-Driver: SPI Interface

| CMSIS-Driver Version 2.6.0 Peripheral Interface for Middleware and Application Code

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Content | Data Structures | Typedefs | Functions
SPI Interface

Driver API for SPI Bus Peripheral (Driver_SPI.h) More...

## Content
| Status Error Codes
| Negative values indicate errors (SPI has specific codes in addition to common Status Error Codes).
| SPI Events
| The SPI driver generates call back events that are notified via the function ARM_SPI_SignalEvent.
| SPI Control Codes
| Many parameters of the SPI driver are configured using the ARM_SPI_Control function.

## Data Structures
struct | ARM_DRIVER_SPI
| Access structure of the SPI Driver. More...
struct | ARM_SPI_CAPABILITIES
| SPI Driver Capabilities. More...
struct | ARM_SPI_STATUS
| SPI Status. More...

## Typedefs
typedef void(* | ARM_SPI_SignalEvent_t )(uint32_t event)
| Pointer to ARM_SPI_SignalEvent : Signal SPI Event. More...

## Functions
ARM_DRIVER_VERSION | ARM_SPI_GetVersion (void)
| Get driver version. More...
ARM_SPI_CAPABILITIES | ARM_SPI_GetCapabilities (void)
| Get driver capabilities. More...
int32_t | ARM_SPI_Initialize (ARM_SPI_SignalEvent_t cb_event)
| Initialize SPI Interface. More...
int32_t | ARM_SPI_Uninitialize (void)
| De-initialize SPI Interface. More...
int32_t | ARM_SPI_PowerControl (ARM_POWER_STATE state)
| Control SPI Interface Power. More...
int32_t | ARM_SPI_Send (const void *data, uint32_t num)
| Start sending data to SPI transmitter. More...
int32_t | ARM_SPI_Receive (void *data, uint32_t num)
| Start receiving data from SPI receiver. More...
int32_t | ARM_SPI_Transfer (const void *data_out, void *data_in, uint32_t num)
| Start sending/receiving data to/from SPI transmitter/receiver. More...
uint32_t | ARM_SPI_GetDataCount (void)
| Get transferred data count. More...
int32_t | ARM_SPI_Control (uint32_t control, uint32_t arg)
| Control SPI Interface. More...
ARM_SPI_STATUS | ARM_SPI_GetStatus (void)
| Get SPI status. More...
void | ARM_SPI_SignalEvent (uint32_t event)
| Signal SPI Events. More...

## Description

Driver API for SPI Bus Peripheral (Driver_SPI.h)

The Serial Peripheral Interface Bus (SPI) implements a synchronous serial bus for data exchange. In microcontroller (MCU) applications, the interface is often used to connect peripheral components at board (PCB) level. SPI devices can operate as Master (SCLK and SS are outputs) or Slave (SCLK and SS are inputs). Wikipedia offers more information about the Serial Peripheral Interface Bus.

Block Diagram

The SPI Driver API defines a SPI interface for middleware components. The SPI Driver supports multiple slaves, but if only one slave is connected, then the Slave Select signal can be omitted.

SPI Master connected to a single slave

SPI Master connected to 3 slaves

The SPI Driver functions control the following SPI signal lines.

Signal | Name | Description
--- | --- | ---
SS | Slave Select (active low) | Selects the slave. This signal can be part of the SPI peripheral or implemented using a GPIO pin.
MOSI | Master Out, Slave In | MOSI output of the Master connects to MOSI input of the Slave.
SCLK | Serial Clock | Serial clock output from Master. Controls the transfer speed and when data are sent and read.
MISO | Master In, Slave Out | MISO input of the Master connects to MISO output of the Slave.

SPI API

The following header files define the Application Programming Interface (API) for the SPI interface:

- Driver_SPI.h : Driver API for SPI Bus Peripheral

The driver implementation is a typical part of the Device Family Pack (DFP) that supports the peripherals of the microcontroller family.

Driver Functions

The driver functions are published in the access struct as explained in Common Driver Functions

- ARM_DRIVER_SPI : access struct for SPI driver functions

Example Code

The following example code shows the usage of the SPI interface.

#include "Driver_SPI.h"
#include "cmsis_os.h" // ARM::CMSIS:RTOS:Keil RTX
void mySPI_Thread(void const *argument);
osThreadId tid_mySPI_Thread;
/* SPI Driver */
extern ARM_DRIVER_SPI Driver_SPI0;
void mySPI_callback(uint32_t event)
{
switch (event)
{
case ARM_SPI_EVENT_TRANSFER_COMPLETE:
/* Success: Wakeup Thread */
osSignalSet(tid_mySPI_Thread, 0x01);
break;
case ARM_SPI_EVENT_DATA_LOST:
/* Occurs in slave mode when data is requested/sent by master
but send/receive/transfer operation has not been started
and indicates that data is lost. Occurs also in master mode
when driver cannot transfer data fast enough. */
__breakpoint(0); /* Error: Call debugger or replace with custom error handling */
break;
case ARM_SPI_EVENT_MODE_FAULT:
/* Occurs in master mode when Slave Select is deactivated and
indicates Master Mode Fault. */
__breakpoint(0); /* Error: Call debugger or replace with custom error handling */
break;
}
}
/* Test data buffers */
const uint8_t testdata_out[8] = { 0, 1, 2, 3, 4, 5, 6, 7 };
uint8_t testdata_in [8];
void mySPI_Thread(void const* arg)
{
ARM_DRIVER_SPI* SPIdrv = &Driver_SPI0;
osEvent evt;
#ifdef DEBUG
ARM_DRIVER_VERSION version;
ARM_SPI_CAPABILITIES drv_capabilities;
version = SPIdrv->GetVersion();
if (version.api < 0x200) /* requires at minimum API version 2.00 or higher */
{ /* error handling */
return;
}
drv_capabilities = SPIdrv->GetCapabilities();
if (drv_capabilities.event_mode_fault == 0)
{ /* error handling */
return;
}
#endif
/* Initialize the SPI driver */
SPIdrv->Initialize(mySPI_callback);
/* Power up the SPI peripheral */
SPIdrv->PowerControl(ARM_POWER_FULL);
/* Configure the SPI to Master, 8-bit mode @10000 kBits/sec */
SPIdrv->Control(ARM_SPI_MODE_MASTER | ARM_SPI_CPOL1_CPHA1 | ARM_SPI_MSB_LSB | ARM_SPI_SS_MASTER_SW | ARM_SPI_DATA_BITS(8), 10000000);
/* SS line = INACTIVE = HIGH */
SPIdrv->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_INACTIVE);
/* thread loop */
while (1)
{
/* SS line = ACTIVE = LOW */
SPIdrv->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_ACTIVE);
/* Transmit some data */
SPIdrv->Send(testdata_out, sizeof(testdata_out));
/* Wait for completion */
evt = osSignalWait(0x01, 100);
if (evt.status == osEventTimeout) {
__breakpoint(0); /* Timeout error: Call debugger */
}
/* SS line = INACTIVE = HIGH */
SPIdrv->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_INACTIVE);
/* SS line = ACTIVE = LOW */
SPIdrv->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_ACTIVE);
/* Receive 8 bytes of reply */
SPIdrv->Receive(testdata_in, 8);
evt = osSignalWait(0x01, 100);
if (evt.status == osEventTimeout) {
__breakpoint(0); /* Timeout error: Call debugger */
}
/* SS line = INACTIVE = HIGH */
SPIdrv->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_INACTIVE);
}
}

## Data Structure Documentation

struct ARM_DRIVER_SPI

Access structure of the SPI Driver.

The functions of the SPI driver are accessed by function pointers exposed by this structure. Refer to Common Driver Functions for overview information.

Each instance of a SPI interface provides such an access structure. The instance is identified by a postfix number in the symbol name of the access structure, for example:

- Driver_SPI0 is the name of the access struct of the first instance (no. 0).
- Driver_SPI1 is the name of the access struct of the second instance (no. 1).

A middleware configuration setting allows connecting the middleware to a specific driver instance Driver_SPIn. The default is 0, which connects a middleware to the first instance of a driver.

### Data Fields
ARM_DRIVER_VERSION(* | GetVersion )(void)
| Pointer to ARM_SPI_GetVersion : Get driver version. More...
ARM_SPI_CAPABILITIES(* | GetCapabilities )(void)
| Pointer to ARM_SPI_GetCapabilities : Get driver capabilities. More...
int32_t(* | Initialize )(ARM_SPI_SignalEvent_t cb_event)
| Pointer to ARM_SPI_Initialize : Initialize SPI Interface. More...
int32_t(* | Uninitialize )(void)
| Pointer to ARM_SPI_Uninitialize : De-initialize SPI Interface. More...
int32_t(* | PowerControl )(ARM_POWER_STATE state)
| Pointer to ARM_SPI_PowerControl : Control SPI Interface Power. More...
int32_t(* | Send )(const void *data, uint32_t num)
| Pointer to ARM_SPI_Send : Start sending data to SPI Interface. More...
int32_t(* | Receive )(void *data, uint32_t num)
| Pointer to ARM_SPI_Receive : Start receiving data from SPI Interface. More...
int32_t(* | Transfer )(const void *data_out, void *data_in, uint32_t num)
| Pointer to ARM_SPI_Transfer : Start sending/receiving data to/from SPI. More...
uint32_t(* | GetDataCount )(void)
| Pointer to ARM_SPI_GetDataCount : Get transferred data count. More...
int32_t(* | Control )(uint32_t control, uint32_t arg)
| Pointer to ARM_SPI_Control : Control SPI Interface. More...
ARM_SPI_STATUS(* | GetStatus )(void)
| Pointer to ARM_SPI_GetStatus : Get SPI status. More...

#### Field Documentation

ARM_DRIVER_VERSION(* GetVersion)(void)

Pointer to ARM_SPI_GetVersion : Get driver version.

ARM_SPI_CAPABILITIES(* GetCapabilities)(void)

Pointer to ARM_SPI_GetCapabilities : Get driver capabilities.

int32_t(* Initialize)(ARM_SPI_SignalEvent_t cb_event)

Pointer to ARM_SPI_Initialize : Initialize SPI Interface.

int32_t(* Uninitialize)(void)

Pointer to ARM_SPI_Uninitialize : De-initialize SPI Interface.

int32_t(* PowerControl)(ARM_POWER_STATE state)

Pointer to ARM_SPI_PowerControl : Control SPI Interface Power.

int32_t(* Send)(const void *data, uint32_t num)

Pointer to ARM_SPI_Send : Start sending data to SPI Interface.

int32_t(* Receive)(void *data, uint32_t num)

Pointer to ARM_SPI_Receive : Start receiving data from SPI Interface.

int32_t(* Transfer)(const void *data_out, void *data_in, uint32_t num)

Pointer to ARM_SPI_Transfer : Start sending/receiving data to/from SPI.

uint32_t(* GetDataCount)(void)

Pointer to ARM_SPI_GetDataCount : Get transferred data count.

int32_t(* Control)(uint32_t control, uint32_t arg)

Pointer to ARM_SPI_Control : Control SPI Interface.

ARM_SPI_STATUS(* GetStatus)(void)

Pointer to ARM_SPI_GetStatus : Get SPI status.

struct ARM_SPI_CAPABILITIES

SPI Driver Capabilities.

A SPI driver can be implemented with different capabilities. The data fields of this structure encode the capabilities implemented by this driver.

Returned by:

- ARM_SPI_GetCapabilities

Data Fields
uint32_t | simplex: 1 | supports Simplex Mode (Master and Slave)
uint32_t | ti_ssi: 1 | supports TI Synchronous Serial Interface
uint32_t | microwire: 1 | supports Microwire Interface
uint32_t | event_mode_fault: 1 | Signal Mode Fault event: ARM_SPI_EVENT_MODE_FAULT.
uint32_t | reserved: 28 | Reserved (must be zero)

struct ARM_SPI_STATUS

SPI Status.

Structure with information about the status of the SPI. The data fields encode busy flag and error flags.

Returned by:

- ARM_SPI_GetStatus

Data Fields
uint32_t | busy: 1 | Transmitter/Receiver busy flag.
uint32_t | data_lost: 1 | Data lost: Receive overflow / Transmit underflow (cleared on start of transfer operation)
uint32_t | mode_fault: 1 | Mode fault detected; optional (cleared on start of transfer operation)
uint32_t | reserved: 29 |

## Typedef Documentation

ARM_SPI_SignalEvent_t

Pointer to ARM_SPI_SignalEvent : Signal SPI Event.

Provides the typedef for the callback function ARM_SPI_SignalEvent.

Parameter for:

- ARM_SPI_Initialize

## Function Documentation

ARM_DRIVER_VERSION ARM_SPI_GetVersion | ( | void |  | ) |

Get driver version.

Returns
  ARM_DRIVER_VERSION

The function ARM_SPI_GetVersion returns version information of the driver implementation in ARM_DRIVER_VERSION

- API version is the version of the CMSIS-Driver specification used to implement this driver.
- Driver version is source code version of the actual driver implementation.

Example:

extern ARM_DRIVER_SPI Driver_SPI0;
ARM_DRIVER_SPI *drv_info;
void setup_spi (void) {
ARM_DRIVER_VERSION version;
drv_info = &Driver_SPI0;
version = drv_info->GetVersion ();
if (version.api < 0x10A) { // requires at minimum API version 1.10 or higher
// error handling
return;
}
}

ARM_SPI_CAPABILITIES ARM_SPI_GetCapabilities | ( | void |  | ) |

Get driver capabilities.

Returns
  ARM_SPI_CAPABILITIES

The function ARM_SPI_GetCapabilities returns information about the capabilities in this driver implementation. The data fields of the structure ARM_SPI_CAPABILITIES encode various capabilities, for example supported modes.

Example:

extern ARM_DRIVER_SPI Driver_SPI0;
ARM_DRIVER_SPI *drv_info;
void read_capabilities (void) {
ARM_SPI_CAPABILITIES drv_capabilities;
drv_info = &Driver_SPI0;
drv_capabilities = drv_info->GetCapabilities ();
// interrogate capabilities
}

int32_t ARM_SPI_Initialize | ( | ARM_SPI_SignalEvent_t | cb_event | ) |

Initialize SPI Interface.

Parameters

  [in] | cb_event | Pointer to ARM_SPI_SignalEvent

Returns
  Status Error Codes

The function ARM_SPI_Initialize initializes the SPI interface.

The parameter cb_event is a pointer to the ARM_SPI_SignalEvent callback function; use a NULL pointer when no callback signals are required.

The function is called when the middleware component starts operation and performs the following:

- Initializes the resources needed for the SPI interface.
- Registers the ARM_SPI_SignalEvent callback function.

Example:

- see SPI Interface - Driver Functions

int32_t ARM_SPI_Uninitialize | ( | void |  | ) |

De-initialize SPI Interface.

Returns
  Status Error Codes

The function ARM_SPI_Uninitialize de-initializes the resources of SPI interface.

It is called when the middleware component stops operation and releases the software resources used by the interface.

int32_t ARM_SPI_PowerControl | ( | ARM_POWER_STATE | state | ) |

Control SPI Interface Power.

Parameters

  [in] | state | Power state

Returns
  Status Error Codes

The function ARM_SPI_PowerControl controls the power modes of the SPI interface.

The parameter state sets the operation and can have the following values:

- ARM_POWER_FULL : set-up peripheral for data transfers, enable interrupts (NVIC) and optionally DMA. Can be called multiple times. If the peripheral is already in this mode the function performs no operation and returns with ARM_DRIVER_OK.
- ARM_POWER_LOW : may use power saving. Returns ARM_DRIVER_ERROR_UNSUPPORTED when not implemented.
- ARM_POWER_OFF : terminates any pending data transfers, disables peripheral, disables related interrupts and DMA.

Refer to Function Call Sequence for more information.

int32_t ARM_SPI_Send | ( | const void * | data,
|  | uint32_t | num
| ) |  |

Start sending data to SPI transmitter.

Parameters

  [in] | data | Pointer to buffer with data to send to SPI transmitter
  [in] | num | Number of data items to send

Returns
  Status Error Codes

This function ARM_SPI_Send is used to send data to the SPI transmitter (received data is ignored).

The parameter data specifies the data buffer.
The parameter num specifies the number of items to send.
The item size is defined by the data type, which depends on the configured number of data bits.

Data type is:

- uint8_t when configured for 1..8 data bits
- uint16_t when configured for 9..16 data bits
- uint32_t when configured for 17..32 data bits

Calling the function ARM_SPI_Send only starts the send operation. When in slave mode, the operation is only registered and started when the master starts the transfer. The function is non-blocking and returns as soon as the driver has started the operation (driver typically configures DMA or the interrupt system for continuous transfer). During the operation it is not allowed to call this function or any other data transfer function again. Also the data buffer must stay allocated and the contents of unsent data must not be modified. When send operation is completed (requested number of items sent), the ARM_SPI_EVENT_TRANSFER_COMPLETE event is generated. Progress of send operation can also be monitored by reading the number of items already sent by calling ARM_SPI_GetDataCount.

Status of the transmitter can also be monitored by calling the ARM_SPI_GetStatus and checking the busy data field, which indicates if transmission is still in progress or pending.

When in master mode and configured to monitor slave select and the slave select gets deactivated during transfer, then the SPI mode changes to inactive and the ARM_SPI_EVENT_MODE_FAULT event is generated (instead of ARM_SPI_EVENT_TRANSFER_COMPLETE).

When in slave mode but send/receive/transfer operation is not started and data is sent/requested by the master, then the ARM_SPI_EVENT_DATA_LOST event is generated.

Send operation can be aborted by calling ARM_SPI_Control with ARM_SPI_ABORT_TRANSFER as the control parameter.

int32_t ARM_SPI_Receive | ( | void * | data,
|  | uint32_t | num
| ) |  |

Start receiving data from SPI receiver.

Parameters

  [out] | data | Pointer to buffer for data to receive from SPI receiver
  [in] | num | Number of data items to receive

Returns
  Status Error Codes

The function ARM_SPI_Receive is used to receive data (transmits the default value as specified by ARM_SPI_Control with ARM_SPI_SET_DEFAULT_TX_VALUE as control parameter).

The parameter data specifies the data buffer.
The parameter num specifies the number of items to receive.
The item size is defined by the data type, which depends on the configured number of data bits.

Data type is:

- uint8_t when configured for 1..8 data bits
- uint16_t when configured for 9..16 data bits
- uint32_t when configured for 17..32 data bits

Calling the function ARM_SPI_Receive only starts the receive operation. The function is non-blocking and returns as soon as the driver has started the operation (driver typically configures DMA or the interrupt system for continuous transfer). When in slave mode, the operation is only registered and started when the master starts the transfer. During the operation it is not allowed to call this function or any other data transfer function again. Also the data buffer must stay allocated. When receive operation is completed (requested number of items received), the ARM_SPI_EVENT_TRANSFER_COMPLETE event is generated. Progress of receive operation can also be monitored by reading the number of items already received by calling ARM_SPI_GetDataCount.

Status of the receiver can also be monitored by calling the ARM_SPI_GetStatus and checking the busy data field, which indicates if reception is still in progress or pending.

When in master mode and configured to monitor slave select and the slave select gets deactivated during transfer, then the SPI mode changes to inactive and the ARM_SPI_EVENT_MODE_FAULT event is generated (instead of ARM_SPI_EVENT_TRANSFER_COMPLETE).

When in slave mode but send/receive/transfer operation is not started and data is sent/requested by the master, then the ARM_SPI_EVENT_DATA_LOST event is generated.

Receive operation can be aborted by calling ARM_SPI_Control with ARM_SPI_ABORT_TRANSFER as the control parameter.

int32_t ARM_SPI_Transfer | ( | const void * | data_out,
|  | void * | data_in,
|  | uint32_t | num
| ) |  |

Start sending/receiving data to/from SPI transmitter/receiver.

Parameters

  [in] | data_out | Pointer to buffer with data to send to SPI transmitter
  [out] | data_in | Pointer to buffer for data to receive from SPI receiver
  [in] | num | Number of data items to transfer

Returns
  Status Error Codes

The function ARM_SPI_Transfer transfers data via SPI. It synchronously sends data to the SPI transmitter and receives data from the SPI receiver.

The parameter data_out is a pointer to the buffer with data to send.
The parameter data_in is a pointer to the buffer which receives data.
The parameter num specifies the number of items to transfer.
The item size is defined by the data type which depends on the configured number of data bits.

Data type is:

- uint8_t when configured for 1..8 data bits
- uint16_t when configured for 9..16 data bits
- uint32_t when configured for 17..32 data bits

Calling the function ARM_SPI_Transfer only starts the transfer operation. The function is non-blocking and returns as soon as the driver has started the operation (driver typically configures DMA or the interrupt system for continuous transfer). When in slave mode, the operation is only registered and started when the master starts the transfer. During the operation it is not allowed to call this function or any other data transfer function again. Also the data buffers must stay allocated and the contents of unsent data must not be modified. When transfer operation is completed (requested number of items transferred), the ARM_SPI_EVENT_TRANSFER_COMPLETE event is generated. Progress of transfer operation can also be monitored by reading the number of items already transferred by calling ARM_SPI_GetDataCount.

Status of the transmitter and receiver can also be monitored by calling the ARM_SPI_GetStatus and checking the busy flag.

When in master mode and configured to monitor slave select and the slave select gets deactivated during transfer, then the SPI mode changes to inactive and the ARM_SPI_EVENT_MODE_FAULT event is generated (instead of ARM_SPI_EVENT_TRANSFER_COMPLETE).

When in slave mode but send/receive/transfer operation is not started and data is sent/requested by the master, then the ARM_SPI_EVENT_DATA_LOST event is generated.

Transfer operation can also be aborted by calling ARM_SPI_Control with ARM_SPI_ABORT_TRANSFER as the control parameter.

uint32_t ARM_SPI_GetDataCount | ( | void |  | ) |

Get transferred data count.

Returns
  number of data items transferred

The function ARM_SPI_GetDataCount returns the number of currently transferred data items during ARM_SPI_Send, ARM_SPI_Receive and ARM_SPI_Transfer operation.

int32_t ARM_SPI_Control | ( | uint32_t | control,
|  | uint32_t | arg
| ) |  |

Control SPI Interface.

Parameters

  [in] | control | Operation
  [in] | arg | Argument of operation (optional)

Returns
  common Status Error Codes and driver specific Status Error Codes

The function ARM_SPI_Control controls the SPI interface settings and executes various operations.

The parameter control is a bit mask that specifies various operations.

- Controls form different categories can be ORed.
- If one control is omitted, then the default value of that category is used.
- Miscellaneous controls cannot be combined.

The parameter arg provides (depending on the parameter control) additional information, for example the Bus Speed.

Parameter control | Bit | Category | Description
--- | --- | --- | ---
ARM_SPI_MODE_INACTIVE | 0..7 | Mode Controls | Set SPI to inactive.
ARM_SPI_MODE_MASTER | Set the SPI Master (Output on MOSI, and the Input on MISO); arg = Bus Speed in bps
ARM_SPI_MODE_MASTER_SIMPLEX | Set the SPI Master (Output and Input on MOSI); arg = Bus Speed in bps
ARM_SPI_MODE_SLAVE | Set the SPI Slave (Output on MISO, and the Input on MOSI)
ARM_SPI_MODE_SLAVE_SIMPLEX | Set the SPI Slave (Output and Input on MISO)
ARM_SPI_CPOL0_CPHA0 (default) | 8..11 | Clock Polarity (Frame Format) | CPOL=0 and CPHA=0: Clock Polarity 0, Clock Phase 0
ARM_SPI_CPOL0_CPHA1 | CPOL=0 and CPHA=1: Clock Polarity 0, Clock Phase 1
ARM_SPI_CPOL1_CPHA0 | CPOL=1 and CPHA=0: Clock Polarity 1, Clock Phase 0
ARM_SPI_CPOL1_CPHA1 | CPOL=1 and CPHA=1: Clock Polarity 1, Clock Phase 1
ARM_SPI_TI_SSI | Specifies that the frame format corresponds to the Texas Instruments Frame Format
ARM_SPI_MICROWIRE | Specifies that the frame format corresponds to the National Microwire Frame Format
ARM_SPI_DATA_BITS(n) | 12..17 | Data Bits | Set the number of bits per SPI frame; range for n = 1..32. This is the minimum required parameter.
ARM_SPI_MSB_LSB (default) | 18 | Bit Order | Set the bit order from MSB to LSB
ARM_SPI_LSB_MSB | Set the bit order from LSB to MSB
ARM_SPI_SS_MASTER_UNUSED (default) | 19..21 | Slave Select when Master Must be used with the corresponding master or slave controls from category Mode Controls. Slave Select when Slave | Set the Slave Select mode for the master to Not used. Used with Mode Control ARM_SPI_MODE_MASTER. Master does not drive or monitor the SS line. For example, when connecting to a single slave, which has the SS line connected to a fixed low level.
ARM_SPI_SS_MASTER_SW | Set the Slave Select mode for the master to Software controlled. Used with Mode Control ARM_SPI_MODE_MASTER. The Slave Select line is configured as output and controlled via the Miscellaneous Control ARM_SPI_CONTROL_SS. By default, the line it is not active (high), and is not affected by transfer-, send-, or receive functions.
ARM_SPI_SS_MASTER_HW_OUTPUT | Set the Slave Select mode for the master to Hardware controlled Output. Used with Mode Control ARM_SPI_MODE_MASTER. The Slave Select line is configured as output and controlled by hardware. The line gets activated or deactivated automatically by the hardware for transfers and is not controlled by the Miscellaneous Control ARM_SPI_CONTROL_SS. When exactly the line is activated or deactivated is hardware dependent. Typically, the hardware will activate the line before starting the transfer and deactivate it after the transfer completes. Some hardware will leave the line activated until the SPI stays master. Note Some devices require that the SS signal is strictly defined regarding transfers. Refer to the documentaiton of your device.
ARM_SPI_SS_MASTER_HW_INPUT | Set the Slave Select mode for the master to Hardware monitored Input. Used with Mode Control ARM_SPI_MODE_MASTER. Used in multi-master configuration where a master does not drive the Slave Select when driving the bus, but rather monitors it. When another master activates this line, the active master backs off. This is called Mode Fault. Slave Select is configured as input and hardware only monitors the line. When the line is deactivated externally while we are master, it presents a Mode Fault (ARM_SPI_EVENT_MODE_FAULT) and the SPI switches to inactive mode.
ARM_SPI_SS_SLAVE_HW (default) | Set the Slave Select mode for the slave to Hardware monitored. Used with Mode Control ARM_SPI_MODE_SLAVE. Hardware monitors the Slave Select line and accepts transfers only when the line is active. Transfers are ignored while the Slave Select line is inactive.
ARM_SPI_SS_SLAVE_SW | Set the Slave Select mode for the slave to Software controlled. Used with Mode Control ARM_SPI_MODE_SLAVE. Used only when the Slave Select line is not used. For example, when a single master and slave are connected in the system then the Slave Select line is not needed. Software controls if the slave is responding or not (by default it is not responding). Software enables or disables transfers by using the Miscellaneous Control ARM_SPI_CONTROL_SS.
ARM_SPI_SET_BUS_SPEED | 0..21 | Miscellaneous Controls (cannot be ORed) | Set the bus speed; arg= Bus Speed in bps
ARM_SPI_GET_BUS_SPEED | Get the bus speed; Retrun values >= 0 reperesent the bus speed in bps. Negative values are Status Error Codes.
ARM_SPI_SET_DEFAULT_TX_VALUE | Set the default transmission value; the parameter arg sets the value
ARM_SPI_CONTROL_SS | Control the Slave Select signal (SS); the values for the parameter arg are: ARM_SPI_SS_INACTIVE; ARM_SPI_SS_ACTIVE
ARM_SPI_ABORT_TRANSFER | Abort the current data transfer

Example

extern ARM_DRIVER_SPI Driver_SPI0;
// configure: SPI master | clock polarity=1, clock phase=1 | bits per frame=16 | bus speed : 1000000
status = Driver_SPI0.Control(ARM_SPI_MODE_MASTER |
ARM_SPI_CPOL1_CPHA1 |
ARM_SPI_DATA_BITS(16), 1000000);

ARM_SPI_STATUS ARM_SPI_GetStatus | ( | void |  | ) |

Get SPI status.

Returns
  SPI status ARM_SPI_STATUS

The function ARM_SPI_GetStatus returns the current SPI interface status.

void ARM_SPI_SignalEvent | ( | uint32_t | event | ) |

Signal SPI Events.

Parameters

  [in] | event | SPI Events notification mask

Returns
  none

The function ARM_SPI_SignalEvent is a callback function registered by the function ARM_SPI_Initialize.

The parameter event indicates one or more events that occurred during driver operation. Each event is encoded in a separate bit and therefore it is possible to signal multiple events within the same call.

Not every event is necessarily generated by the driver. This depends on the implemented capabilities stored in the data fields of the structure ARM_SPI_CAPABILITIES, which can be retrieved with the function ARM_SPI_GetCapabilities.

The following events can be generated:

Parameter event | Bit | Description | supported when ARM_SPI_CAPABILITIES
--- | --- | --- | ---
ARM_SPI_EVENT_TRANSFER_COMPLETE | 0 | Occurs after call to ARM_SPI_Send, ARM_SPI_Receive, or ARM_SPI_Transfer to indicate that all the data has been transferred. The driver is ready for the next transfer operation. | allways supported
ARM_SPI_EVENT_DATA_LOST | 1 | Occurs in slave mode when data is requested/sent by master but send/receive/transfer operation has not been started and indicates that data is lost. Occurs also in master mode when driver cannot transfer data fast enough. | allways supported
ARM_SPI_EVENT_MODE_FAULT | 2 | Occurs in master mode when Slave Select is deactivated and indicates Master Mode Fault. The driver is ready for the next transfer operation. | data field event_mode_fault = 1